## -*- coding: utf-8 -*-
################################################################
## File : /sshx:zope@ulysse:/home/zope/z8082/Products/Educastream/Extensions/Install.py
## Author : Sylvain Viollon
## Email : sylvain@pilotsystems.net
## Creation Date : Thu Aug 23 12:02:01 2007 CEST
## Last modification : Thu Aug 23 15:34:41 2007 CEST
################################################################

__author__ = "sylvain@pilotsystems.net"
__format__ = "plaintext"
__version__ = "$Id: Install.py 2 2007-11-13 17:09:41Z gael.le-mignot $"



from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.Archetypes.public import listTypes, process_types
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

from Products.SharedDocumentBase.config import PROJECTNAME, GLOBALS, SKINS_DIR

from Products.SharedDocumentBase.tools.SharedBaseTool import SharedBaseTool

from Products.ZCatalog.Catalog import CatalogError


def install(self):
    """
    Install this product
    """
    out = StringIO()
    portal = getToolByName(self, 'portal_url').getPortalObject()
    print >> out, 'Installing %s' % PROJECTNAME

    ## Install skin
    install_subskin(self, out, GLOBALS, SKINS_DIR)
    print >> out, 'Installed skin.'

    ## Install types
    types = listTypes(PROJECTNAME)
    installTypes(self, out, types, PROJECTNAME)
    print >> out, 'Installed types.'

    ## Enable portal_factory for the new content types
    factory = getToolByName(self, 'portal_factory')
    new_types, useless1, useless2 = process_types(types, PROJECTNAME)
    types = factory.getFactoryTypes().keys()
    for new_type in new_types:
	if new_type.portal_type not in types:
	    types.append(new_type.portal_type)
    factory.manage_setPortalFactoryTypes(listOfTypeIds=types)
    print >> out, "Added new content types to 'portal_factory'."

    ## Add tools
    for obj in (SharedBaseTool,):
        id = obj.id
        if getToolByName(portal, id, None) is None:
            t = obj()
            portal._setObject(id, t)

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()
