## -*- coding: utf-8 -*-

__author__ = "gael@pilotsystems.net"
__format__ = "plaintext"
__version__ = "$Id: __init__.py 2 2007-11-13 17:09:41Z gael.le-mignot $"



from Products.CMFCore.utils import ToolInit, ContentInit
from Products.CMFCore.DirectoryView import registerDirectory
from Products.Archetypes.public import process_types, listTypes
from config import GLOBALS, SKINS_DIR, PROJECTNAME

registerDirectory(SKINS_DIR, GLOBALS)

def initialize(context):
    from tools import SharedBaseTool
    from contents import *

    ## Initialize tools
    tools = (SharedBaseTool.SharedBaseTool,
             )
    for tool in tools:
        ToolInit(tool.meta_type,
                 tools=(tool,),
                 icon='tool.gif').initialize(context)

    ## Initialize content types
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECTNAME, atype.archetype_name)
        permission = '%s: Add %s' % (PROJECTNAME,
                                     atype.archetype_name)
        ContentInit(kind,
                    content_types=(atype, ),
                    permission=permission,
                    extra_constructors=(constructor, ),
                    fti=ftis).initialize(context)

