## -*- coding: utf-8 -*-

__author__ = "gael@pilotsystems.net"
__format__ = "plaintext"
__version__ = "$Id: EduFile.py 40 2007-08-29 16:09:46Z sylvain.viollon $"


from AccessControl import ClassSecurityInfo
from AccessControl import getSecurityManager
from AccessControl import Unauthorized

from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import *

from Products.BlobFile.file import BlobFileSchema, BlobFile
from Products.blob.file import default_blobdir

from zope.interface import implements
from Products.SharedDocumentBase.interfaces import ISharedObject

from sharedmixin import SharedMixin

import os

schema = BlobFileSchema.copy()


class SharedFile(BlobFile, SharedMixin):
    """File for shared document database"""

    implements(ISharedObject)

    ## Type, icon and description
    meta_type = portal_type     = 'SharedFile'
    archetype_name              = 'Shared File'
    content_icon                = 'file_icon.gif'
    typeDescription             = 'File for shared document database'

    ## Various settings
    global_allow                = False

    ## Security shortcuts
    security                    = ClassSecurityInfo()

    schema                      = schema

    security.declareProtected("View", "getFileName")
    def getFileName(self):
        """
        Get the real file name
        """
        field = self.schema["file"]
        field = field.get(self)
        blobfile = field.data
        fd = blobfile.open()
        return fd.name

    ##
    ## Ensure default view is view, not download
    ##
        
    def __call__(self):
        """
        Render the default view
        """
        view = getattr(self, self.default_view)
        return view()

    index_html = __call__

# sharedmixin.inject(SharedFile)

registerType(SharedFile)
