## -*- coding: utf-8 -*-

__author__ = "gael@pilotsystems.net"
__format__ = "plaintext"
__version__ = "$Id: EduFolder.py 22 2007-08-26 19:01:23Z souheil.chelfouh $"

from AccessControl import ClassSecurityInfo

from Products.Archetypes.public import *
from Products.ATContentTypes.content.schemata import finalizeATCTSchema
from Products.ATContentTypes.content.folder import ATFolder, ATFolderSchema

from zope.interface import implements
from Products.SharedDocumentBase.interfaces import ISharedObject

from sharedmixin import SharedMixin

schema = ATFolderSchema.copy()

class SharedFolder(ATFolder, SharedMixin):
    """A Folder containing shared files"""

    implements(ISharedObject)

    ## Type, icon and description
    meta_type = portal_type     = 'SharedFolder'
    archetype_name              = 'Shared Folder'
    content_icon                = 'folder_icon.gif'
    typeDescription             = 'A Folder containing shared files'

    ## Views
    default_view                = 'base_view'
    immediate_view              = default_view
    suppl_views                 = ()

    ## Various settings
    global_allow                = True
    filter_content_types        = True
    allowed_content_types       = ('SharedFolder', 'SharedFile',)

    ## Security shortcuts
    security                    = ClassSecurityInfo()

    schema                      = schema

    security.declarePublic('canSetDefaultPage')
    def canSetDefaultPage(self): return False

registerType(SharedFolder)
